package en.MaxedOut.UltraRespawn;

import java.util.Iterator;
import java.io.IOException;
import java.util.HashMap;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.plugin.Plugin;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.Particle;
import org.bukkit.Sound;
import java.io.File;

public class Config
{
    private File f;
    private String configVersion;
    public boolean enabled;
    public boolean showNameTag;
    public boolean playSound;
    public Sound sound;
    public boolean keepVelocity;
    public boolean blindness;
    public int blindnessTime;
    public boolean tnttagDisable;
    public boolean alternateMethod;
    public boolean spawnProtection;
    public int spawnProtectionTime;
    public boolean spawnParticles;
    public boolean spawnProtectFlash;
    public Particle spawnParticleType;
    
    public Config() {
        this.f = new File(Main.instance.getDataFolder() + File.separator + "config.yml");
        this.configVersion = "1.1";
        this.enabled = true;
        this.showNameTag = false;
        this.playSound = false;
        this.sound = Sound.ENTITY_PLAYER_DEATH;
        this.blindness = false;
        this.blindnessTime = 20;
        this.tnttagDisable = false;
        this.alternateMethod = false;
        this.spawnProtection = false;
        this.spawnProtectionTime = 30;
        this.spawnParticles = false;
        this.spawnProtectFlash = false;
        this.spawnParticleType = Particle.TOTEM;
        Main.instance.saveDefaultConfig();
        new BukkitRunnable() {
            public void run() {
                Config.this.updateConfig();
            }
        }.runTaskLater((Plugin)Main.instance, 10L);
    }
    
    public void updateConfig() {
        YamlConfiguration yaml = YamlConfiguration.loadConfiguration(this.f);
        if (yaml.getString("configVersion") == null) {
            this.updateConfigVersion();
            yaml = YamlConfiguration.loadConfiguration(this.f);
        }
        if (!yaml.getString("configVersion").equals(this.configVersion)) {
            this.updateConfigVersion();
            yaml = YamlConfiguration.loadConfiguration(this.f);
        }
        this.enabled = yaml.getBoolean("enabled");
        this.showNameTag = yaml.getBoolean("showNameTag");
        this.playSound = yaml.getBoolean("playSound");
        this.sound = Sound.valueOf(yaml.getString("sound"));
        if (this.sound == null) {
            this.playSound = false;
            this.sound = Sound.ENTITY_PLAYER_DEATH;
        }
        this.keepVelocity = yaml.getBoolean("keepVelocity");
        this.blindness = yaml.getBoolean("blindness");
        this.blindnessTime = yaml.getInt("blindnessTime");
        this.tnttagDisable = yaml.getBoolean("tnttagDisable");
        this.alternateMethod = yaml.getBoolean("alternateMethod");
        this.spawnProtection = yaml.getBoolean("spawnProtection");
        this.spawnProtectionTime = yaml.getInt("spawnProtectionTime");
        this.spawnParticles = yaml.getBoolean("spawnParticles");
        this.spawnProtectFlash = yaml.getBoolean("spawnProtectFlash");
        this.spawnParticleType = Particle.valueOf(yaml.getString("spawnParticleType"));
        if (this.spawnParticleType == null) {
            this.spawnParticles = false;
            this.spawnParticleType = Particle.TOTEM;
        }
    }
    
    public void updateConfigVersion() {
        YamlConfiguration yaml = YamlConfiguration.loadConfiguration(this.f);
        final HashMap<String, Object> configValues = new HashMap<String, Object>();
        for (final String key : yaml.getKeys(false)) {
            configValues.put(key, yaml.get(key));
        }
        this.f.delete();
        Main.instance.saveDefaultConfig();
        yaml = YamlConfiguration.loadConfiguration(this.f);
        for (final String key : configValues.keySet()) {
            if (yaml.getString(key) != null) {
                yaml.set(key, configValues.get(key));
            }
        }
        yaml.set("configVersion", (Object)this.configVersion);
        try {
            yaml.save(this.f);
        }
        catch (final IOException e) {
            e.printStackTrace();
        }
    }
}
